library angular2.change_detection_dart;

export './src/change_detection/parser/ast.dart' show AST;
export './src/change_detection/parser/lexer.dart' show Lexer;
export './src/change_detection/parser/parser.dart' show Parser;
export './src/change_detection/parser/context_with_variable_bindings.dart'
    show ContextWithVariableBindings;
export './src/change_detection/exceptions.dart'
    show ExpressionChangedAfterItHasBeenChecked, ChangeDetectionError;
export './src/change_detection/interfaces.dart'
    show
        ChangeRecord,
        ChangeDispatcher,
        ChangeDetector,
        CHECK_ONCE,
        CHECK_ALWAYS,
        DETACHED,
        CHECKED;
export './src/change_detection/proto_change_detector.dart'
    show
        ProtoChangeDetector,
        DynamicProtoChangeDetector,
        JitProtoChangeDetector;
export './src/change_detection/dynamic_change_detector.dart'
    show DynamicChangeDetector;
import './src/change_detection/proto_change_detector.dart'
    show
        ProtoChangeDetector,
        DynamicProtoChangeDetector,
        JitProtoChangeDetector;

class ChangeDetection {
  ProtoChangeDetector createProtoChangeDetector(String name) {
    return null;
  }
}
class DynamicChangeDetection extends ChangeDetection {
  ProtoChangeDetector createProtoChangeDetector(String name) {
    return new DynamicProtoChangeDetector();
  }
}
class JitChangeDetection extends ChangeDetection {
  ProtoChangeDetector createProtoChangeDetector(String name) {
    return new JitProtoChangeDetector();
  }
}
var dynamicChangeDetection = new DynamicChangeDetection();
var jitChangeDetection = new JitChangeDetection();
