library angular2.src.change_detection.parser.context_with_variable_bindings_dart;

import 'package:angular2/src/facade/collection.dart' show MapWrapper;
import 'package:angular2/src/facade/lang.dart' show BaseException;

class ContextWithVariableBindings {
  dynamic parent;
  Map varBindings;
  ContextWithVariableBindings(dynamic parent, Map varBindings) {
    this.parent = parent;
    this.varBindings = varBindings;
  }
  bool hasBinding(String name) {
    return MapWrapper.contains(this.varBindings, name);
  }
  get(String name) {
    return MapWrapper.get(this.varBindings, name);
  }
  set(String name, value) {
    if (this.hasBinding(name)) {
      MapWrapper.set(this.varBindings, name, value);
    } else {
      throw new BaseException(
          'VariableBindings do not support setting of new keys post-construction.');
    }
  }
  clearValues() {
    for (var k in MapWrapper.keys(this.varBindings)) {
      MapWrapper.set(this.varBindings, k, null);
    }
  }
}
