library angular2.src.core.annotations.annotations_dart;

import 'package:angular2/src/facade/lang.dart'
    show ABSTRACT, CONST, normalizeBlank, isPresent;
import 'package:angular2/src/facade/collection.dart' show ListWrapper, List;

@ABSTRACT()
class Directive {
  final dynamic selector;
  final dynamic bind;
  final dynamic lightDomServices;
  final dynamic implementsTypes;
  final dynamic lifecycle;
  @CONST()
  const Directive(
      {selector, bind, lightDomServices, implementsTypes, lifecycle})
      : selector = selector,
        lightDomServices = lightDomServices,
        implementsTypes = implementsTypes,
        bind = bind,
        lifecycle = lifecycle;
  bool hasLifecycleHook(String hook) {
    return isPresent(this.lifecycle)
        ? ListWrapper.contains(this.lifecycle, hook)
        : false;
  }
}
class Component extends Directive {
  final dynamic lightDomServices;
  final dynamic shadowDomServices;
  final dynamic componentServices;
  final dynamic lifecycle;
  @CONST()
  const Component({selector, bind, lightDomServices, shadowDomServices,
      componentServices, implementsTypes, lifecycle})
      : lightDomServices = lightDomServices,
        shadowDomServices = shadowDomServices,
        componentServices = componentServices,
        lifecycle = lifecycle,
        super(
            selector: selector,
            bind: bind,
            lightDomServices: lightDomServices,
            implementsTypes: implementsTypes,
            lifecycle: lifecycle);
}
class Decorator extends Directive {
  final bool compileChildren;
  @CONST()
  const Decorator({selector, bind, lightDomServices, implementsTypes, lifecycle,
      compileChildren: true})
      : compileChildren = compileChildren,
        super(
            selector: selector,
            bind: bind,
            lightDomServices: lightDomServices,
            implementsTypes: implementsTypes,
            lifecycle: lifecycle);
}
class Viewport extends Directive {
  @CONST()
  const Viewport({selector, bind, lightDomServices, implementsTypes, lifecycle})
      : super(
          selector: selector,
          bind: bind,
          lightDomServices: lightDomServices,
          implementsTypes: implementsTypes,
          lifecycle: lifecycle);
}
const onDestroy = "onDestroy";
const onChange = "onChange";
