library angular2.src.core.compiler.pipeline.text_interpolation_parser_dart;

import 'package:angular2/src/facade/lang.dart'
    show RegExpWrapper, StringWrapper, isPresent;
import 'package:angular2/src/facade/dom.dart' show Node, DOM;
import 'package:angular2/change_detection.dart' show Parser;
import './compile_step.dart' show CompileStep;
import './compile_element.dart' show CompileElement;
import './compile_control.dart' show CompileControl;

class TextInterpolationParser extends CompileStep {
  Parser _parser;
  dynamic _compilationUnit;
  TextInterpolationParser(Parser parser, dynamic compilationUnit) : super() {
    this._parser = parser;
    this._compilationUnit = compilationUnit;
  }
  process(
      CompileElement parent, CompileElement current, CompileControl control) {
    if (!current.compileChildren || current.ignoreBindings) {
      return;
    }
    var element = current.element;
    var childNodes = DOM.templateAwareRoot(element).childNodes;
    for (var i = 0; i < childNodes.length; i++) {
      var node = childNodes[i];
      if (identical(node.nodeType, Node.TEXT_NODE)) {
        this._parseTextNode(current, node, i);
      }
    }
  }
  _parseTextNode(pipelineElement, node, nodeIndex) {
    var ast =
        this._parser.parseInterpolation(node.nodeValue, this._compilationUnit);
    if (isPresent(ast)) {
      DOM.setText(node, ' ');
      pipelineElement.addTextNodeBinding(nodeIndex, ast);
    }
  }
}
