library angular2.src.core.compiler.view_pool_dart;

import 'package:angular2/src/facade/collection.dart'
    show ListWrapper, MapWrapper, StringMapWrapper, List;
import './view.dart' show View;

class ViewPool {
  List<View> _views;
  num _capacity;
  ViewPool(num capacity) {
    this._views = [];
    this._capacity = capacity;
  }
  View pop() {
    return ListWrapper.isEmpty(this._views)
        ? null
        : ListWrapper.removeLast(this._views);
  }
  push(View view) {
    if (this._views.length < this._capacity) {
      ListWrapper.push(this._views, view);
    }
  }
  length() {
    return this._views.length;
  }
}
