library angular2.src.test_lib.benchmark_util_dart;

import 'package:angular2/src/facade/dom.dart' show DOM, document, location;
import 'package:angular2/src/facade/lang.dart'
    show NumberWrapper, BaseException, isBlank;

getIntParameter(String name) {
  return NumberWrapper.parseInt(getStringParameter(name), 10);
}
getStringParameter(String name) {
  var els = DOM.querySelectorAll(document, '''input[name=\"${name}\"]''');
  var value;
  var el;
  for (var i = 0; i < els.length; i++) {
    el = els[i];
    if ((!identical(el.type, 'radio') && !identical(el.type, 'checkbox')) ||
        el.checked) {
      value = el.value;
      break;
    }
  }
  if (isBlank(value)) {
    throw new BaseException(
        '''Could not find and input field with name ${name}''');
  }
  return value;
}
bindAction(String selector, Function callback) {
  var el = DOM.querySelector(document, selector);
  DOM.on(el, 'click', (_) {
    callback();
  });
}
