library angular2.test.core.compiler.shadow_dom.content_tag_spec_dart;

import 'package:angular2/test_lib.dart'
    show describe, beforeEach, it, expect, ddescribe, iit, SpyObject, el, proxy;
import 'package:angular2/src/facade/lang.dart' show IMPLEMENTS;
import 'package:angular2/src/facade/dom.dart' show DOM;
import 'package:angular2/src/core/compiler/shadow_dom_emulation/content_tag.dart'
    show Content;
import 'package:angular2/src/core/dom/element.dart' show NgElement;
import 'package:angular2/src/core/compiler/shadow_dom_emulation/light_dom.dart'
    show LightDom;

@proxy
class DummyLightDom extends SpyObject implements LightDom {
  noSuchMethod(m) {
    super.noSuchMethod(m);
  }
}
var _script = '''<script type=\"ng/content\"></script>''';
main() {
  describe('Content', () {
    it("should insert the nodes", () {
      var parent = el("<div><content></content></div>");
      var content = DOM.firstChild(parent);
      var c = new Content(null, new NgElement(content));
      c.insert([el("<a></a>"), el("<b></b>")]);
      expect(DOM.getInnerHTML(parent))
          .toEqual('''${_script}<a></a><b></b>${_script}''');
    });
    it("should remove the nodes from the previous insertion", () {
      var parent = el("<div><content></content></div>");
      var content = DOM.firstChild(parent);
      var c = new Content(null, new NgElement(content));
      c.insert([el("<a></a>")]);
      c.insert([el("<b></b>")]);
      expect(DOM.getInnerHTML(parent))
          .toEqual('''${_script}<b></b>${_script}''');
    });
    it("should insert empty list", () {
      var parent = el("<div><content></content></div>");
      var content = DOM.firstChild(parent);
      var c = new Content(null, new NgElement(content));
      c.insert([el("<a></a>")]);
      c.insert([]);
      expect(DOM.getInnerHTML(parent)).toEqual('''${_script}${_script}''');
    });
  });
}
